FROM node:22-alpine AS base


ENV PNPM_HOME="/usr/local/pnpm"
ENV PATH="${PNPM_HOME}:${PATH}"

ARG NEXT_PUBLIC_HUB_URL
ARG NEXT_PUBLIC_HUB_SERVER_URL
ARG NEXT_PUBLIC_DISCORD_URL
ARG NEXT_PUBLIC_MOODLE_URL
ARG NEXT_PUBLIC_DISPATCH_URL

ENV NEXT_PUBLIC_HUB_URL=${NEXT_PUBLIC_HUB_URL}
ENV NEXT_PUBLIC_HUB_SERVER_URL=${NEXT_PUBLIC_HUB_SERVER_URL}
ENV NEXT_PUBLIC_DISCORD_URL=${NEXT_PUBLIC_DISCORD_URL}
ENV NEXT_PUBLIC_MOODLE_URL=${NEXT_PUBLIC_MOODLE_URL}
ENV NEXT_PUBLIC_DISPATCH_URL=${NEXT_PUBLIC_DISPATCH_URL}

RUN corepack enable && corepack prepare pnpm@latest --activate


RUN echo "NEXT_PUBLIC_DISCORD_URL=${NEXT_PUBLIC_DISCORD_URL}"
RUN pnpm add -g turbo@^2.5

FROM base AS builder
RUN apk update
RUN apk add --no-cache libc6-compat

WORKDIR /usr/app

COPY . .

RUN turbo prune hub --docker

FROM base AS installer
RUN apk update
RUN apk add --no-cache libc6-compat

WORKDIR /usr/app

COPY --from=builder /usr/app/out/json/ .
RUN pnpm install

# Build the project
COPY --from=builder /usr/app/out/full/ .

RUN turbo run build

FROM base AS runner
WORKDIR /usr/app

# Don't run production as root
RUN addgroup --system --gid 1001 nodejs
RUN adduser --system --uid 1001 nextjs
USER nextjs

# Automatically leverage output traces to reduce image size
# https://nextjs.org/docs/advanced-features/output-file-tracing
COPY --from=installer --chown=nextjs:nodejs /usr/app/ ./

# Expose the application port
EXPOSE 3000

CMD ["pnpm", "--dir", "apps/hub", "run", "start"]